; Ŀ
;  Procedure:  MainMenu                                                    
;  Purpose: Mainmenu is the first procedure loaded by the GO script.       
;  It is a closed procedure so it does not require any private variables,  
;  nor does is release any variables existing prior to its execution.      
;  MainMenu should load the error procedure as one of its first operations.
;                                                                          
;    This script is part of a sample application described in the          
;    October 1993 issue of Paradox Information.  This script was written   
;    by Cary Jensen of Data Works of Houston.                              
;                                                                          
;    This script is for demonstration purposes only.  No representation    
;    is made concerning the appropriateness of this script for any other   
;    purpose.  If you use this script you agree to hold its author and     
;    Data Works of Houston free from any claim arising out of the use or   
;    misuse of this script.                                                
; ͵
;                              Cary Jensen                                 
;                          Data Works of Houston                           
;                             CIS 76307,1533                               
;                             (713) 359-3311                               
; ͵
; 
PROC CLOSED MainMenu()

;=================================;
; Use any valid procedure library name
;=================================;
Autolib = "Paradox"      ;Since this is a close procedure, this definition of
                         ;of autolib does not affect any existing definitions.

;=================================;
; Define the error procedure.
;=================================;

ErrorProc = "Error"

;=================================;
; Set variable Development to False when delivering application.
; Define or set any additional variables or arrays required by app.
;=================================;
Development = True  ;This variable disables the error procedure when True

;=================================;
; Set any other global varibles  or arrays needed.  In this application, the 
; variables are PromptColor and IsCompatible and arrays are WindowStyle
; and TableStyle.
;=================================;
MENU HOME 
IF MENUCHOICE() = CHR(240)
  THEN
    IsCompatible = False
  ELSE
    IsCompatible = True
    QUIT "Sorry.  This demonstration application must be run in Standard mode."
ENDIF
ESC

PromptColor = SYSCOLOR(0)


DYNARRAY WindowStyle[]
DYNARRAY TableWindow[]
TableWindow["ORIGINCOL"] = -1000
TableWindow["ORIGINROW"] = -1000

;=================================;
; Test any conditions necessary for the successful run of 
; this application. 
;=================================;
SWITCH
; CASE ISBLANKZERO():
;   ErrorBox("Configuration error: Blank=Zero. Use CCP to change. Contact administrator")
;   EXIT
    ;Often you need an application to have certain configuration settings.  
    ;Test for those settings here.  If the necessary settings are not
    ;correct, exit the application.  Each application can use a different
    ;configuration file.  See the Getting Started manual for more information.
  CASE VERSION() < 4:
    QUIT "Sorry, this demonstration application must be run in Paradox 4.0 or later."
ENDSWITCH

;=================================;
;This is the main application loop
;=================================;

WHILE True
  PROMPT
  Splash(True)    ;This splash screen displays the application logo
  
  SHOWPULLDOWN
    "View"          :"View a table."               :"View"
      SUBMENU
        "Clients"      :"View the Clients table."  :"ViewClients",
        "C~o~untry"    :"View the Country table."  :"ViewCountry"
      ENDSUBMENU,
    "Edit"             :"Edit a table."            :"Edit"
      SUBMENU
        "Clients"      :"Edit the Clients table."  :"EditClients",
        "C~o~untry"    :"Edit the Country table."  :"EditCountry"
      ENDSUBMENU,
    "Report"           :"Output a report."         :"Report"
      SUBMENU
        "Clients"      :"Report the Clients table.":"ViewClients"
          SUBMENU
            "Labels"   :"Generate mailing labels." :"ReportClientLabels"
              SUBMENU
                "All"  :"Report all"               :"ReportClientLabelsAll",
                "One"  :"Report one"               :"ReportClientLabelsOne"
              ENDSUBMENU,
            "Flip file":"Generate flip file cards.":"ReportClientFlipFile"
              SUBMENU
                "All"  :"Report all"               :"ReportClientFlipFileAll",
                "One"  :"Report one"               :"ReportClientFlipFileOne"
              ENDSUBMENU
          ENDSUBMENU,          
        "C~o~untry"    :"Report the Country table.":"ReportCountry"
      ENDSUBMENU,
    "Leave"            :"Return to DOS."           :"Leave"
      SUBMENU
        "Cancel"       :"Do not leave."            :"LeaveCancel",
        "OK"           :"Leave now."               :"LeaveOK"
      ENDSUBMENU
  ENDMENU
  
  GETMENUSELECTION TO Choice
  SHOWPULLDOWN ENDMENU      ;This removes the standard Paradox menu.

;=================================;
; All reponses to menu selections are produced by calling a procedure.
; The following switch statement identifies the select menu item
; and then calls the appropriate procedure.
;=================================;


  SWITCH
    CASE Choice = "ViewClients":
      ViewTab("Clients","1", 23, 78)

    CASE Choice = "ViewCountry":
      ViewTab("Country","1", 19, 38)

    CASE Choice = "EditClients":
      EditTab("Clients","1", 23, 78)

    CASE Choice = "EditCountry":
      EditTab("Country","1", 19, 38)

    CASE Choice = "ReportClientLabelsAll":
      GenRep("Clients",1)

    CASE Choice = "ReportClientLabelsOne":
      GetCode(1)
      IF NOT Retval
        THEN
          LOOP
      ENDIF
      GenRep("Answer",1)

    CASE Choice = "ReportClientFlipFileAll":
      GenRep("Clients",2)

    CASE Choice = "ReportClientFlipFileOne":
      GetCode(2)
      IF NOT Retval
        THEN
          LOOP
      ENDIF
      GenRep("Answer",2)

    CASE Choice = "ReportCountry":
      GenRep("Country",1)
      
    CASE Choice = "LeaveOK":
      ;The user wants to quit.  Exit the application.
      QUIT
  
  ENDSWITCH

ENDWHILE
ENDPROC ; --- MainMenu()  *CLOSED
;This last line writes the defined procedure to a procedure library.
;All scripts in this application have been converted to procedures.
;For more information on procedures, please read the conference paper
;Introduction to Procedures and Procedure librarys by Cary Jensen.
WRITELIB "Paradox" MainMenu
RELEASE PROCS MainMenu
